#> snc:entity/ticks
# Manages entities functions in every tick
#
# @input
#   Any entity
#
# @output
#   Behavior for each entity

# Disable mobs
function snc:entity/disable_mobs

## This first section handle almost everything related with players and shifters
## For this datapack, villagers are almost the same as a player
execute if entity @s[type=#snc:human] run function snc:entity/human

# Village
# Show blood
execute as @s[type=armor_stand,tag=body] unless predicate snc:is_riding run particle minecraft:block minecraft:redstone_block ^ ^ ^ 0 0 0 1 20
execute as @s[tag=marleyan] run function snc:marleyan/select_marleyan

# If titan
execute as @s[type=!player,tag=titan] run function snc:titans/main

# If shifter
execute as @s[tag=shifter,type=!player,type=!villager] run function snc:shifters/select_dead

# Kill unless is a titan or a villager
execute as @s[type=zombie_villager,tag=!titan] run function snc:controller/kill_mob

execute as @s[tag=flare] run function snc:player/gun/flare/select_color

## This second part handle pure titans
execute as @s[type=pig] run function snc:titans/trigger

# push back
execute if score @s push_back matches 0.. run function snc:controller/push_back

# animate hurt
execute if entity @s[type=!#snc:not_bleed] if predicate snc:is_hurt if entity @s[tag=!killed] run particle minecraft:block minecraft:redstone_block ^ ^1 ^-.45 0 0 0 1 30

## Interact with stuff
execute as @s[type=interaction] run function snc:interact/main

# Set Motion to not moving projectiles
execute as @s[tag=not_mov] rotated as @p run function snc:controller/apply_motion/main
# Projectile Effects
execute as @s[tag=projectile] run function snc:player/gun/select_effect
# Bullet Effects (If has bullet Ex: Spears, Canons, etc...)
execute as @s[tag=bullet] run function snc:player/gun/select_bullet

# ODM
execute if entity @s[tag=odm] run function snc:player/odm/main


# Detect Item
execute as @s[type=falling_block,tag=debris] run function snc:item/debris/main