#> snc:shifters/mobs/colossal/timer/controller
# Controlls the player who has the shifter, tracking attributes such as health, if it disconnects, if its hurt.
#
# @Input:
#   Detects if player with shifter is doing an action.
#
# @Output:
#   Based on the action triggers other functions.

function snc:shifters/mobs/colossal/timer/select_transform

tag @s add shifter
## Remove transform
execute if entity @s[tag=injured] if predicate snc:is_hurt run function snc:shifters/hit

execute store result score #x_colossal shifter_vars run data get entity @s Pos[0]
execute store result score #z_colossal shifter_vars run data get entity @s Pos[2]

# Set titan's current health to the corresponding scoreboard.
execute store result score titan_health_bar colossal_vars run data get entity @s AbsorptionAmount
execute if score titan_health_bar colossal_vars matches 0 run tag @s[tag=!first] add injured
execute if score titan_health_bar colossal_vars matches 20.. run tag @s remove injured
# Set player's current health to the corresponding scoreboard.
execute if entity @s[tag=first] store result score player_health_bar colossal_vars run data get entity @s Health
execute if entity @s[tag=first] if score player_health_bar colossal_vars matches ..10 run function snc:shifters/select_trigger

# Effects on curse
execute if score curse config matches 0 run function snc:shifters/mobs/colossal/remove/sick/short
execute if score curse config matches 1 run function snc:shifters/mobs/colossal/remove/sick/normal
execute if score curse config matches 2 run function snc:shifters/mobs/colossal/remove/sick/large

# Display the type of transform (Only colossal)
execute as @s[tag=!transform] if score ticks clock matches 1 if predicate snc:has_add if predicate snc:is_sneaking run function snc:shifters/mobs/colossal/display_trigger
execute as @s[tag=!transform] if score ticks clock matches 11 if predicate snc:has_add if predicate snc:is_sneaking run function snc:shifters/mobs/colossal/display_trigger